package com.company;

import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Scanner;

import static java.lang.Integer.parseInt;

public class Main {

    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in, StandardCharsets.US_ASCII);
        String[] inputFirst = scan.nextLine().split(" ");
        String[] inputScnd = scan.nextLine().split(" ");
        int output = 0;

        int boothsCount = parseInt(inputFirst[0]);
        int dist = parseInt(inputFirst[1]);

        ArrayList<Integer> positions = new ArrayList<>();

        for (int i = 0; i < boothsCount; i++) {
            positions.add(parseInt(inputScnd[i]));
        }

        positions.sort(Integer::compareTo);

        double aver = 0;


        for (int i = 0; i < positions.size(); i++) {
            aver += positions.get(i);
        }

        aver = aver / positions.size();


        double diff = 0;
        double diffMin = Integer.MAX_VALUE;
        int posMin = 0;

        for (int i = 0; i < positions.size(); i++) {
            diff = (aver - positions.get(i));
            if (diffMin > diff) {
                diffMin = diff;
                posMin = i;
            }
        }

        int[] bigger = new int[positions.size()];
        int[] smaller = new int[positions.size()];
        int pom1 = 0;
        int pom2 = 0;

        for (int i = 0; i < positions.size(); i++) {
            if (i == posMin)
                continue;

            if (i < posMin)
                smaller[pom1++] = positions.get(i);
            else
                bigger[pom2++] = positions.get(i);
        }

        output += positions.get(posMin) - smaller[posMin -1] - dist;
        output += positions.get(posMin) - bigger[0] + dist;
        for (int i = 1; i < posMin; i++){
            output += smaller[posMin - i] - smaller[posMin - i - 1] - dist;
    }
        for (int i = 1; i < positions.size(); i++){
            output += bigger[i] - bigger[i-1] + dist;
        }

        System.out.println(output);
    }
}
